// CASTORFile.cpp: implementation of the CASTORFile class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "EvolveTraffic.h"
#include "CASTORFile.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CASTORFile::CASTORFile(std::string inputFile, std::string outputFile)
{
	inFile.open(inputFile.c_str(), std::ios::in);
	outFile.open(outputFile.c_str(), std::ios::out);
	pTruck = singleTruck;
}

CASTORFile::~CASTORFile()
{

}

Truck* CASTORFile::readLine()
{
	std::string str;

	std::getline(inFile, str, '\n');

	if(str != "")
	{
		Truck* tempTruck = new Truck();		// this assumes they are all trucks - they may not be
		tempTruck->createCASTORTruck(str);
		return tempTruck;
	}

	return NULL;
}

void CASTORFile::writeLine(Vehicle *pVeh,const double curTime)
{
	pVeh->doCASTORData(pTruck, curTime);
	outFile << pTruck << std::endl;
}
