// Define constants for EvolveTraffic

#ifndef Constants_h
#define Constants_h

#include "stdafx.h"	// this is for the defs of WORD etc

	// Road driving
	const bool DRIVE_ON_RIGHT		= true;

	// Input File Types
	const WORD SAFT					= 100U;
	const WORD CASTOR				= 101U;

	// Supported Distributions
	const WORD DIST_EXPONENTIAL		= 200U;
	const WORD DIST_LOGNORMAL		= 201U;
	const WORD DIST_GAMMA			= 202U;
	const WORD DIST_GUMBEL			= 203U;
	const WORD DIST_POISSON			= 204U;
	const WORD DIST_GEV				= 205U;
	const WORD DIST_NORMAL			= 206U;
	const WORD DIST_CONST			= 207U;

	// IDM Parameter IDs
	const WORD IDM_PARAM_T			= 300U;
	const WORD IDM_PARAM_A			= 301U;
	const WORD IDM_PARAM_B			= 302U;
	const WORD IDM_PARAM_S0			= 303U;
	const WORD IDM_PARAM_S1			= 304U;
	const WORD IDM_PARAM_V0			= 305U;
	const WORD IDM_PARAM_DELTA		= 306U;
	const WORD IDM_PARAM_POLITE		= 307U;
	const WORD IDM_PARAM_BIAS		= 308U;
	const WORD IDM_PARAM_DB			= 309U;

	// Vehicle types
	const WORD VEH_ID_CAR			= 0;
	const WORD VEH_ID_SMALLTRUCK	= 1;
	const WORD VEH_ID_LARGETRUCK	= 2;
	const WORD VEH_ID_CRANE			= 3;
	const WORD VEH_ID_LOWLOADER		= 4;

	// Colours for vehicles (which can change)
	const COLORREF VEH_COLOR_CAR		= RGB(190,190,190);
	const COLORREF VEH_COLOR_SMALLTRUCK	= RGB(0,0,255);
	const COLORREF VEH_COLOR_LARGETRUCK	= RGB(255,0,0);
	const COLORREF VEH_COLOR_CRANE		= RGB(0,255,0);
	const COLORREF VEH_COLOR_LOWLOADER	= RGB(100,100,100);

	// Colours for elements
	const COLORREF CLR_BACKGRND			= RGB(255,255,255);
	const COLORREF CLR_ROAD_SURFACE		= RGB(200,200,200);
	const COLORREF CLR_ROAD_LINES		= RGB(0,0,0);
	const COLORREF CLR_RULER_LINES		= RGB(0,0,0);
	const COLORREF CLR_RULER_TEXT		= RGB(0,0,0);
	const COLORREF CLR_LEGEND_TEXT		= RGB(0,0,0);
	
	// Program Version for Serialization
	const UINT VERSION_NUMBER			= 1;

	// Input file buffer size
	const WORD INPUT_FILE_BUFFER_SIZE	= 10U;

	// The refresh rate for OnDraw
	const WORD DRAW_FRAMES_PER_SEC		= 20U;

	// Time output constants
	const WORD MTS_PER_YR				= 10;
	const WORD DAYS_PER_MT				= 25;

	// Some unusual constants to be queried, but as per Treiber's software
	const double SPACE_MIN				= 27.0;
	const double SAFE_BRAKING			= -12.0;
	const double MIN_GAP				= 2.0;
	const double T_DELAY				= 1.6;	// what is this?

#endif //!defined(Constants.h)

// Supported Distributions

//0 - Exponential
//1 - Log-normal
//2 - Gamma
//3 - Gumbel
//4 - Poisson
//5 - GEV
//6 - Normal

// IDM Parameters

// m_T;			// Safe time headway
// m_a;			// Maximum acceleration
// m_b;			// desired decceleration
// m_s0;		// Jam distance s0
// m_s1;		// Jam distance s1
// m_v0;		// desired velocity
// m_delta;		// Acceleration exponent
// polite;		// Politness factor
// biasRight;	// Bias factor for slow lane