// Detector.cpp: implementation of the Detector class.
//
//////////////////////////////////////////////////////////////////////

#include "Detector.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Detector::Detector(int loc, bool DirPos, FileHandler* fh)
{
	m_Location = loc;
	m_DirPos = DirPos;
	m_pFileHandler = fh;
}

Detector::~Detector()
{

}

void Detector::addVehicle(Vehicle *pVeh)
{
	m_Vehicles.push_back(pVeh);
}

std::vector<Vehicle*> Detector::getVehicles()
{
	return m_Vehicles;
}

int Detector::getPos()
{
	return m_Location;
}
/*
int Detector::getMode()
{
	return m_Mode;
}
*/
void Detector::clear()
{
	m_Vehicles.clear();
}

bool Detector::getDirection()
{
	return m_DirPos;
}

void Detector::WriteVehiclesToFile(const double curTime)
{
	for(int i = 0; i < m_Vehicles.size(); i++)
		m_pFileHandler->writeLine(m_Vehicles.at(i), curTime);
	// once written, they must be deleted
	m_Vehicles.clear();
}

void Detector::setFileHandler(FileHandler *fh)
{
	m_pFileHandler = fh;
}
