// Detector.h: interface for the Detector class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DETECTOR_H__F90280E9_BFD2_40CF_A999_86FF1E9DDE15__INCLUDED_)
#define AFX_DETECTOR_H__F90280E9_BFD2_40CF_A999_86FF1E9DDE15__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include<vector>
#include "Truck.h"		// surely all vehicles must use detectors?
// #include "Vehicle.h" // why is this removed?

#include "CASTORFile.h"
#include "SAFTFile.h"

class Detector  
{
public:
	void setFileHandler(FileHandler* fh);
	void WriteVehiclesToFile(const double curTime);
	bool getDirection();
	void clear();
	//int getMode();
	int getPos();
	std::vector<Vehicle*> getVehicles();
	void addVehicle(Vehicle* pVeh);
	Detector(int loc, bool DirPos, FileHandler* fh);
	virtual ~Detector();

private:
	FileHandler* m_pFileHandler;
	int m_Location;
	//int m_Mode;
	bool m_DirPos;
	std::vector<Vehicle*> m_Vehicles;

};

#endif // !defined(AFX_DETECTOR_H__F90280E9_BFD2_40CF_A999_86FF1E9DDE15__INCLUDED_)
