#ifndef _DIRECTION_H
#define _DIRECTION_H

#include <vector>
#include "Vehicle.h"
#include "Lane.h"

//using namespace std;

typedef std::vector< std::vector<Vehicle*> > M2D;

class Direction {

public:
	void setOutputDetector(Detector* OutputDet);
	Detector* getOutputDetector();
	Lane& getLane(int i);
	int getNoLanes();
	M2D getVehiclesM2D();
	M2D getGlobalPos();
	void createLanes(int length,int nLanes, std::vector<Detector*> detectors);
	void init(bool DirPos, Detector* OutDet, bool AllowLaneChange);

	Direction();
	virtual ~Direction();

	bool update(double step, const double curTime);

private:
	bool m_AllowLaneChanging;
	double flow;
	double len; 
	bool m_DirPos;
	int m_NoLanes;
	std::vector<Lane> m_vLanes;
	Detector* m_OutputDetector;

};
#endif