#ifndef _DRIVERMODEL_H
#define _DRIVERMODEL_H

#include <math.h>
#include "Constants.h"

class DriverModel {

public:
	DriverModel();
	virtual ~DriverModel();

	virtual double getDesiredVel() = 0;
	virtual double update(double vel, double dist) = 0;
	virtual void setVel(double vel) = 0;

	// double because we want to send back info to let the vehicle decide
	virtual double LaneChange(	double GapToFront, 
								double GapToBack, 
								double FrontChangeAccel,
								double CurrentBackAccel, 
								double ProposedBackAccel, 
								bool overtake) = 0;

};

#endif
