// EvolveTrafficDoc.cpp : implementation of the CEvolveTrafficDoc class
//

#include "stdafx.h"
#include "EvolveTraffic.h"

#include "EvolveTrafficDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEvolveTrafficDoc

IMPLEMENT_DYNCREATE(CEvolveTrafficDoc, CDocument)

BEGIN_MESSAGE_MAP(CEvolveTrafficDoc, CDocument)
	//{{AFX_MSG_MAP(CEvolveTrafficDoc)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEvolveTrafficDoc construction/destruction

CEvolveTrafficDoc::CEvolveTrafficDoc()
{
	m_IDMParams_Car			.setVehicleTypeID(VEH_ID_CAR);
	m_IDMParams_SmallTruck	.setVehicleTypeID(VEH_ID_SMALLTRUCK);
	m_IDMParams_LargeTruck	.setVehicleTypeID(VEH_ID_LARGETRUCK);
	m_IDMParams_Crane		.setVehicleTypeID(VEH_ID_CRANE);
	m_IDMParams_Lowloader	.setVehicleTypeID(VEH_ID_LOWLOADER);
}

CEvolveTrafficDoc::~CEvolveTrafficDoc()
{
}

BOOL CEvolveTrafficDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	m_FileIn = _T("Please select a file");
	m_FileOut = _T("Please select a file");
	m_RoadLength = 1500;
	m_NoLanesDirPos = 2;
	m_NoLanesDirNeg = 1;
	m_FileType = CASTOR;
	m_SimTimeStep = 0.1;
	UpdateDerivedMembers();

	// MessageBox(AfxGetMainWnd()->m_hWnd,"New Document!","EvolveTraffic",MB_OK);

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CEvolveTrafficDoc serialization

void CEvolveTrafficDoc::Serialize(CArchive& ar)
{
	m_IDMParams_Car			.Serialize(ar);
	m_IDMParams_SmallTruck	.Serialize(ar);
	m_IDMParams_LargeTruck	.Serialize(ar);
	m_IDMParams_Crane		.Serialize(ar);
	m_IDMParams_Lowloader	.Serialize(ar);

	if (ar.IsStoring())
	{
		ar	<< m_FileIn
			<< m_FileOut
			<< m_FileType
			<< m_TrafFileNoLanesDirPos
			<< m_TrafFileNoLanesDirNeg
			<< m_NoDirections
			<< m_NoLanes
			<< m_NoLanesDirPos
			<< m_NoLanesDirNeg
			<< m_RoadLength
			<< m_SimTimeStep
			<< m_PosOutputDetectorDirPos
			<< m_PosOutputDetectorDirNeg
			<< m_AllowLaneChanging;
	}
	else
	{
		ar	>> m_FileIn
			>> m_FileOut
			>> m_FileType
			>> m_TrafFileNoLanesDirPos
			>> m_TrafFileNoLanesDirNeg
			>> m_NoDirections
			>> m_NoLanes
			>> m_NoLanesDirPos
			>> m_NoLanesDirNeg
			>> m_RoadLength
			>> m_SimTimeStep
			>> m_PosOutputDetectorDirPos
			>> m_PosOutputDetectorDirNeg
			>> m_AllowLaneChanging;
	}
}

/////////////////////////////////////////////////////////////////////////////
// CEvolveTrafficDoc diagnostics

#ifdef _DEBUG
void CEvolveTrafficDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CEvolveTrafficDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CEvolveTrafficDoc commands

void CEvolveTrafficDoc::UpdateDerivedMembers()
{
	m_NoLanes = m_NoLanesDirPos + m_NoLanesDirNeg;
	m_NoDirections = (m_NoLanesDirPos > 0 && m_NoLanesDirNeg > 0) ? 2 : 1;

	SetModifiedFlag();	// To implement Save Changes prompts
}

void CEvolveTrafficDoc::initSim()
{
	m_Sim.setFileIn( (LPCTSTR)m_FileIn );
	m_Sim.setFileOut( (LPCTSTR)m_FileOut );
	m_Sim.setFileType(m_FileType);
	m_Sim.setNoDirections(m_NoDirections);
	m_Sim.setNoLanes(m_NoLanes);
	m_Sim.setNoLanesDirPos(m_NoLanesDirPos);
	m_Sim.setNoLanesDirNeg(m_NoLanesDirNeg);
	m_Sim.setRoadLength(m_RoadLength);
	m_Sim.setSimTimeStep(m_SimTimeStep);

	m_Sim.getRoad()->setIDMParams_Car		(&m_IDMParams_Car);
	m_Sim.getRoad()->setIDMParams_SmallTruck(&m_IDMParams_SmallTruck);
	m_Sim.getRoad()->setIDMParams_LargeTruck(&m_IDMParams_LargeTruck);
	m_Sim.getRoad()->setIDMParams_Crane		(&m_IDMParams_Crane);
	m_Sim.getRoad()->setIDMParams_Lowloader	(&m_IDMParams_Lowloader);

	m_Sim.getRoad()->setTrafFileNoLanesDirPos(m_TrafFileNoLanesDirPos);
	m_Sim.getRoad()->setTrafFileNoLanesDirNeg(m_TrafFileNoLanesDirNeg);
	m_Sim.getRoad()->setPosOuputDetectorDirPos(m_PosOutputDetectorDirPos);
	m_Sim.getRoad()->setPosOuputDetectorDirNeg(m_PosOutputDetectorDirNeg);
	m_Sim.getRoad()->setAllowLaneChanging(m_AllowLaneChanging);
	
	m_Sim.init();
}

// Private Member Sets
void CEvolveTrafficDoc::setRoadLength(int L)
{
	m_RoadLength = L;
	SetModifiedFlag();	// To implement Save Changes prompts
}

void CEvolveTrafficDoc::setNoLanes(int nl)
{
	m_NoLanes = nl;
	SetModifiedFlag();	// To implement Save Changes prompts
}

void CEvolveTrafficDoc::setNoDirections(int nd)
{
	m_NoDirections = nd;
	SetModifiedFlag();	// To implement Save Changes prompts
}

void CEvolveTrafficDoc::setSimTimeStep(double ts)
{
	m_SimTimeStep = ts;
	SetModifiedFlag();	// To implement Save Changes prompts
}

void CEvolveTrafficDoc::setNoLanesDirPos(int nlpos)
{
	m_NoLanesDirPos = nlpos;
	SetModifiedFlag();	// To implement Save Changes prompts
}

void CEvolveTrafficDoc::setNoLanesDirNeg(int nlneg)
{
	m_NoLanesDirNeg = nlneg;
	SetModifiedFlag();	// To implement Save Changes prompts
}

void CEvolveTrafficDoc::setFileIn(CString file)
{
	m_FileIn = file;
	SetModifiedFlag();	// To implement Save Changes prompts
}

void CEvolveTrafficDoc::setFileOut(CString file)
{
	m_FileOut = file;
	SetModifiedFlag();	// To implement Save Changes prompts
}

void CEvolveTrafficDoc::setFileType(WORD fileType)
{
	m_FileType = fileType;
	SetModifiedFlag();	// To implement Save Changes prompts
}

void CEvolveTrafficDoc::setIDMParams_Car(CIDMParameterSet theSet)
{
	m_IDMParams_Car = theSet;
	SetModifiedFlag();	// To implement Save Changes prompts
}

void CEvolveTrafficDoc::setIDMParams_SmallTruck(CIDMParameterSet theSet)
{
	m_IDMParams_SmallTruck = theSet;
	SetModifiedFlag();	// To implement Save Changes prompts
}

void CEvolveTrafficDoc::setIDMParams_LargeTruck(CIDMParameterSet theSet)
{
	m_IDMParams_LargeTruck = theSet;
	SetModifiedFlag();	// To implement Save Changes prompts
}

void CEvolveTrafficDoc::setIDMParams_Crane(CIDMParameterSet theSet)
{
	m_IDMParams_Crane = theSet;
	SetModifiedFlag();	// To implement Save Changes prompts
}

void CEvolveTrafficDoc::setIDMParams_Lowloader(CIDMParameterSet theSet)
{
	m_IDMParams_Lowloader = theSet;
	SetModifiedFlag();	// To implement Save Changes prompts
}

void CEvolveTrafficDoc::setTrafFileNoLanesDirPos(int nl)
{
	m_TrafFileNoLanesDirPos = nl;
	SetModifiedFlag();
}

void CEvolveTrafficDoc::setTrafFileNoLanesDirNeg(int nl)
{
	m_TrafFileNoLanesDirNeg = nl;
	SetModifiedFlag();
}

void CEvolveTrafficDoc::setPosOutputDetectorDirPos(int loc)
{
	m_PosOutputDetectorDirPos = loc;
}

void CEvolveTrafficDoc::setPosOutputDetectorDirNeg(int loc)
{
	m_PosOutputDetectorDirNeg = loc;
}

void CEvolveTrafficDoc::setAllowLaneChanging(BOOL status)
{
	m_AllowLaneChanging = status;
}
