// EvolveTrafficDoc.h : interface of the CEvolveTrafficDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_EVOLVETRAFFICDOC_H__E9AF4E58_CB5C_4E2F_94AC_B1498A1C476A__INCLUDED_)
#define AFX_EVOLVETRAFFICDOC_H__E9AF4E58_CB5C_4E2F_94AC_B1498A1C476A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "afxtempl.h"
#include "Sim.h"
#include "IDMParameterSet.h"

class CEvolveTrafficDoc : public CDocument
{
protected: // create from serialization only
	CEvolveTrafficDoc();
	DECLARE_DYNCREATE(CEvolveTrafficDoc)

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CEvolveTrafficDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	//}}AFX_VIRTUAL

// Implementation
public:
	
	
	void initSim();
	Sim m_Sim;
	void UpdateDerivedMembers();

	// The gets
	WORD	getFileType()		const {return m_FileType;};
	CString getFileIn()			const {return m_FileIn;};
	CString getFileOut()		const {return m_FileOut;};
	int		getNoLanesDirPos()	const {return m_NoLanesDirPos;};
	int		getNoLanesDirNeg()	const {return m_NoLanesDirNeg;};
	double	getSimTimeStep()	const {return m_SimTimeStep;};
	int		getNoDirections()	const {return m_NoDirections;};
	int		getNoLanes()		const {return m_NoLanes;};
	int		getRoadLength()		const {return m_RoadLength;};
	int		getTrafFileNoLanesDirPos()	const {return m_TrafFileNoLanesDirPos;};
	int		getTrafFileNoLanesDirNeg()	const {return m_TrafFileNoLanesDirNeg;};
	int		getPosOutputDetectorDirPos()const {return m_PosOutputDetectorDirPos;};
	int		getPosOutputDetectorDirNeg()const {return m_PosOutputDetectorDirNeg;};
	BOOL	getAllowLaneChanging()		const {return m_AllowLaneChanging;};

	CIDMParameterSet getIDMParams_Car()			const {return m_IDMParams_Car;};
	CIDMParameterSet getIDMParams_SmallTruck()	const {return m_IDMParams_SmallTruck;};
	CIDMParameterSet getIDMParams_LargeTruck()	const {return m_IDMParams_LargeTruck;};
	CIDMParameterSet getIDMParams_Crane()		const {return m_IDMParams_Crane;};
	CIDMParameterSet getIDMParams_Lowloader()	const {return m_IDMParams_Lowloader;};
	
	// The sets	
	void	setFileType(WORD fileType);	
	void	setFileIn(CString file);
	void	setFileOut(CString file);
	void	setNoLanesDirPos(int nlpos);
	void	setNoLanesDirNeg(int nlneg);
	void	setSimTimeStep(double ts);
	void	setNoDirections(int nd);
	void	setNoLanes(int nl);	
	void	setRoadLength(int L);
	void	setTrafFileNoLanesDirPos(int nl);
	void	setTrafFileNoLanesDirNeg(int nl);
	void	setPosOutputDetectorDirPos(int loc);
	void	setPosOutputDetectorDirNeg(int loc);
	void	setAllowLaneChanging(BOOL status);
	
	void	setIDMParams_Car		(CIDMParameterSet theSet);
	void	setIDMParams_SmallTruck	(CIDMParameterSet theSet);
	void	setIDMParams_LargeTruck	(CIDMParameterSet theSet);
	void	setIDMParams_Crane		(CIDMParameterSet theSet);
	void	setIDMParams_Lowloader	(CIDMParameterSet theSet);
	
	virtual ~CEvolveTrafficDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CEvolveTrafficDoc)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	BOOL	m_AllowLaneChanging;
	int		m_PosOutputDetectorDirPos;
	int		m_PosOutputDetectorDirNeg;
	int		m_TrafFileNoLanesDirPos;
	int		m_TrafFileNoLanesDirNeg;
	int		m_NoVehicleClasses;
	CString m_FileIn;
	CString m_FileOut;
	WORD	m_FileType;
	int		m_NoLanesDirPos;
	int		m_NoLanesDirNeg;
	double	m_SimTimeStep;
	int		m_NoDirections;
	int		m_NoLanes;
	int		m_RoadLength;
	CIDMParameterSet m_IDMParams_Car;
	CIDMParameterSet m_IDMParams_SmallTruck;
	CIDMParameterSet m_IDMParams_LargeTruck;
	CIDMParameterSet m_IDMParams_Crane;
	CIDMParameterSet m_IDMParams_Lowloader;
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_EVOLVETRAFFICDOC_H__E9AF4E58_CB5C_4E2F_94AC_B1498A1C476A__INCLUDED_)
