// EvolveTrafficView.h : interface of the CEvolveTrafficView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_EVOLVETRAFFICVIEW_H__A8EBCCBD_29B8_4AA3_BF81_C9D991006520__INCLUDED_)
#define AFX_EVOLVETRAFFICVIEW_H__A8EBCCBD_29B8_4AA3_BF81_C9D991006520__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class CEvolveTrafficView : public CScrollView
{
protected: // create from serialization only
	CEvolveTrafficView();
	DECLARE_DYNCREATE(CEvolveTrafficView)

// Attributes
public:
	CEvolveTrafficDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CEvolveTrafficView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual void OnInitialUpdate(); // called first time after construct
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CEvolveTrafficView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CEvolveTrafficView)
	afx_msg void OnConfigSim();
	afx_msg void OnRunEvolveTraffic();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnConfigTraf();
	afx_msg void OnToolsPrefs();
	afx_msg void OnToolsPause();
	afx_msg void OnToolsZoomin();
	afx_msg void OnToolsZoomout();
	afx_msg void OnToolsSpeedup();
	afx_msg void OnToolsSlowdown();
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	int m_TimerSpeed;
	int Round(double val) {return int(val + 0.5);};
	
	void UpdateDrawRect();
	void SetTheTimer();
	void SettingUpdateRedraw();
	void ScaleChangeUpdate(double factor);

	void initRoad();	
	void DrawRoad(CMemDC* pDC);	
	void DrawRuler(CMemDC* pDC);
	void DrawLegend(CMemDC* pDC);
	void DrawVehicle(CMemDC* pDC, Vehicle* veh);

	int		m_SimStepsPerDraw;
	int		m_TimerID;
	bool	m_bTrucksReadIn;
	bool	m_bTimerHasTicked;
	CRect	m_ClientRect;
	int		m_YCoordTop;
	RECT	m_RoadRect;
	bool	m_bAnimate;
	bool	m_bInSimulation;

	double	m_Scale;
	double	m_TimeWarp;
	double	m_VehicleLengthScale;
	double	m_VehicleWidth;	
	double	m_TickLength;
	int		m_TickStep;
	double	m_LaneWidth;
	double	m_Border_Top;
	double	m_Border_Btm;
	double	m_Border_Lhs;
	double	m_Border_Rhs;

	int		m_NoDirections;
	int		m_NoLanes;
	int		m_NoLanesDirPos;
	int		m_NoLanesDirNeg;
	int		m_RoadLength;	
	int		m_NoTicks;
	int		m_RoadWidth;
	
	CEvolveTrafficDoc* m_pDoc;

};

#ifndef _DEBUG  // debug version in EvolveTrafficView.cpp
inline CEvolveTrafficDoc* CEvolveTrafficView::GetDocument()
   { return (CEvolveTrafficDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_EVOLVETRAFFICVIEW_H__A8EBCCBD_29B8_4AA3_BF81_C9D991006520__INCLUDED_)
