#ifndef _IDM_H
#define _IDM_H

#include "DriverModel.h"

class IDM : public DriverModel 
{

public:
	IDM();
	virtual ~IDM();
	double update(double vel, double dist);

	// The gets
	double get_T();
	double get_A();
	double get_B();
	double get_S0();
	double get_S1();
	double get_V0();
	double get_Delta();
	double get_Polite();
	double get_Bias();
	double get_DB();	

	// The sets
	void set_T		(double val);
	void set_A		(double val);
	void set_B		(double val);
	void set_S0		(double val);
	void set_S1		(double val);
	void set_V0		(double val);
	void set_Delta	(double val);
	void set_Polite	(double val);
	void set_Bias	(double val);
	void set_DB		(double val);

private:
	// Parameters of model
	double m_T;			// Safe time headway
	double m_A;			// Maximum acceleration
	double m_B;			// desired decceleration
	double m_S0;		// Jam distance s0
	double m_S1;		// Jam distance s1
	double m_V0;		// desired velocity
	double m_Delta;		// Acceleration exponent
	double m_Polite;	// for MOBIL, considers other drivers
	double m_Bias;		// for MOBIL, keeps to slow lane
	double m_DB;		// for MOBIL, damps overtaking occurrences

	double m_SafeBraking;	// are these fully-fledged parameters?
	double m_MinGap;

// Operations
public:
	double getDesiredVel();			// kept because of base class
	void setVel(double vel);		// set current velocity

	// Lane changing
	double LaneChange(	double GapToFront, 
						double GapToBack, 
						double FrontChangeAccel,
						double CurrentBackAccel, 
						double ProposedBackAccel, 
						bool overtake);

private:
	// properties of vehicle
	double m_speed;
	double s_star(double vel);
	double dvdt(double m_speed, double s);

};
#endif
