#if !defined(AFX_IDMPARAMETERSET_H__134C1BE2_9D40_4A62_B20D_65C2D5901FE6__INCLUDED_)
#define AFX_IDMPARAMETERSET_H__134C1BE2_9D40_4A62_B20D_65C2D5901FE6__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// IDMParameterSet.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CIDMParameterSet view

#include "Parameter.h"
#include "IDM.h"
#include "afxtempl.h"

class CIDMParameterSet : public CObject
{
public:
	CIDMParameterSet();
	CIDMParameterSet(WORD id);
	virtual ~CIDMParameterSet();
	CIDMParameterSet(const CIDMParameterSet& ParamSet);
	
	DECLARE_SERIAL(CIDMParameterSet)

// Attributes
public:

// Operations
public:
	void Serialize(CArchive& ar);   // overridden for i/o

	CIDMParameterSet& operator=(const CIDMParameterSet &param);

// Implementation
public:
	IDM Generate();
	// The gets
	CParameter* get_T();
	CParameter* get_A();
	CParameter* get_B();
	CParameter* get_S0();
	CParameter* get_S1();
	CParameter* get_V0();
	CParameter* get_Delta();
	CParameter* get_Polite();
	CParameter* get_Bias();
	CParameter* get_DB();	
	int getVehicleTypeID() const;
	
	// The sets
	void set_T		(CParameter* param);
	void set_A		(CParameter* param);
	void set_B		(CParameter* param);
	void set_S0		(CParameter* param);
	void set_S1		(CParameter* param);
	void set_V0		(CParameter* param);
	void set_Delta	(CParameter* param);
	void set_Polite	(CParameter* param);
	void set_Bias	(CParameter* param);
	void set_DB		(CParameter* param);	
	void setVehicleTypeID(int id);

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

private:
	void setAll(const CIDMParameterSet &ParamSet);
	void buildParamSet();
	int m_VehicleTypeID;

	CParameter m_T;
	CParameter m_A;
	CParameter m_B;
	CParameter m_S0;
	CParameter m_S1;
	CParameter m_V0;
	CParameter m_Delta;
	CParameter m_Polite;
	CParameter m_Bias;
	CParameter m_DB;
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_IDMPARAMETERSET_H__134C1BE2_9D40_4A62_B20D_65C2D5901FE6__INCLUDED_)
