// Lane.h: interface for the Lane class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_LANE_H__3506F588_71F6_4DF9_AF0A_10B8BA4B9F50__INCLUDED_)
#define AFX_LANE_H__3506F588_71F6_4DF9_AF0A_10B8BA4B9F50__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Vehicle.h"
#include "Detector.h"

using namespace std;

	/**A class representing a lane in a road*/

class Lane  
{
public:
	void setOutputDetector(Detector* out);
	Lane();
	Lane(int length, std::vector<Detector*> detectors, bool DirPos, bool AllowLaneChange);
	virtual ~Lane();
	
	bool	update(double step);
	int		getIndex();
	double	getLastPos();
	int		getNoVeh();
	double	getLength();
	
	//double	calcAccel(Vehicle* bVeh, Vehicle* fVeh);
	void	insert(int i, Vehicle* pVeh);
	bool	ChangeLanes(Vehicle* pVeh);
	void	setRightLane(Lane* right);
	void	setLeftLane(Lane* left);
	
	std::vector<Vehicle*> getPos();	// why return a vector of vehicles?
									// surely should be called getVehicles()

private:
	Vehicle* FinadAdjacentVehicle(Lane* AdjacentLane, double location, 
									bool front, int* iAdjacentLane = NULL);
	void ImplementLaneChange(Vehicle* pVeh, int LaneChangeID, int iVehLeftLane, int iVehRightLane);
	void AddVehicleToDetector(double prevPosition, double curPosition, Vehicle* pVeh);
	
	std::vector<Vehicle*> m_pVehicles;
	std::vector<Detector*> m_vDetectors;

	int		m_Dir;
	static int m_index;
	int		m_iLane;
	double	m_Flow;
	double	m_RoadLength;
	int		m_NoVeh;
	double	m_PrevVehiclePosition;
	bool	m_AllowLaneChanging;
	bool	m_DirPos;

	Lane* m_LeftLane;
	Lane* m_RightLane;
	Detector* m_OutputDetector;
	
	//Generator generator;
};

#endif // !defined(AFX_LANE_H__3506F588_71F6_4DF9_AF0A_10B8BA4B9F50__INCLUDED_)
