#ifndef _SIM_H
#define _SIM_H

#include "Direction.h"
#include "Road.h"
#include <vector>
#include <iostream>
#include <fstream>
#include <string>

using namespace std;

typedef std::vector< std::vector<Vehicle*> > M2D;

	/** A class to represent the simulation handler */

class Sim {

public:
	void setFileIn(string file);
	void setFileOut(string file);
	void setFileType(WORD fileType);
	void setNoLanesDirPos(int nlpos);
	void setNoLanesDirNeg(int nlneg);
	void setSimTimeStep(double ts);
	void setNoDirections(int nd);
	void setNoLanes(int nl);
	void setRoadLength(int L);
	
	double getCurrentSimTime();

	Road* getRoad();

	double getRoadLength();
	M2D getPositions();
	M2D doOneTimeStep(bool* pInSimulation);
	void init();
	Sim();
	virtual  ~Sim();

private:
	double m_CurrentSimTime;
    Road m_Road;
	M2D m_vVehicles;
	string m_FileIn;
	string m_FileOut;
	WORD m_FileType;
	int m_NoLanesDirPos;
	int m_NoLanesDirNeg;
	double m_SimTimeStep;
	int m_NoDirections;
	int m_NoLanes;
	int m_RoadLength;
};
#endif
