// SimConfigDlg.cpp : implementation file
//

#include "stdafx.h"
#include "EvolveTraffic.h"
#include "SimConfigDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSimConfigDlg dialog


CSimConfigDlg::CSimConfigDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSimConfigDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSimConfigDlg)
	m_FileIn = _T("Please select a file");
	m_RoadLength = 5000;
	m_NoLanesDirPos = 1;
	m_NoLanesDirNeg = 1;
	m_FileType = CASTOR;
	m_SimTimeStep = 100;
	m_TrafFileNoLanesDirPos = -1;
	m_TrafFileNoLanesDirNeg = -1;
	m_FileOut = _T("Please specify a filename");
	m_DriveSide = -1;
	m_PosOutputDetectorDirPos = 0;
	m_AllowLaneChanging = true;
	m_PosOutputDetectorDirPos = 0;
	//}}AFX_DATA_INIT
}


void CSimConfigDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSimConfigDlg)
	DDX_Text(pDX, IDC_EDT_FILE_IN, m_FileIn);
	DDX_Text(pDX, IDC_EDT_ROADLENGTH, m_RoadLength);
	DDV_MinMaxInt(pDX, m_RoadLength, 500, 100000);
	DDX_CBIndex(pDX, IDC_CMB_LANESDIRPOS, m_NoLanesDirPos);
	DDX_CBIndex(pDX, IDC_CMB_LANESDIRNEG, m_NoLanesDirNeg);
	DDX_Text(pDX, IDC_EDT_SIMTIMESTEP, m_SimTimeStep);
	DDV_MinMaxInt(pDX, m_SimTimeStep, 10, 2000);
	DDX_CBIndex(pDX, IDC_CMB_TRAFFILE_LANESDIR1, m_TrafFileNoLanesDirPos);
	DDX_CBIndex(pDX, IDC_CMB_TRAFFILE_LANESDIR2, m_TrafFileNoLanesDirNeg);
	DDX_Text(pDX, IDC_EDT_FILE_OUT, m_FileOut);
	DDX_CBIndex(pDX, IDC_CMB_DRIVESIDE, m_DriveSide);
	DDX_Text(pDX, IDC_EDT_DIRPOSDETECTOR, m_PosOutputDetectorDirPos);
	DDX_Text(pDX, IDC_EDT_DIRNEGDETECTOR, m_PosOutputDetectorDirNeg);
	DDX_Check(pDX, IDC_CHECK_LANECHNG, m_AllowLaneChanging);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSimConfigDlg, CDialog)
	//{{AFX_MSG_MAP(CSimConfigDlg)
	ON_BN_CLICKED(IDC_BTN_FILEINPICK, OnBtnFileInPick)
	ON_BN_CLICKED(IDC_BTN_FILEOUTPICK, OnBtnFileOutPick)
	ON_BN_CLICKED(IDC_RAD_CASTOR, OnRadCastor)
	ON_BN_CLICKED(IDC_RAD_SAFT, OnRadSaft)
	ON_EN_CHANGE(IDC_EDT_ROADLENGTH, OnChangeEdtRoadlength)
	ON_CBN_EDITCHANGE(IDC_CMB_LANESDIRPOS, OnEditchangeCmbLanesdirPos)
	ON_CBN_EDITCHANGE(IDC_CMB_LANESDIRNEG, OnEditchangeCmbLanesdirNeg)
	ON_EN_CHANGE(IDC_EDT_SIMTIMESTEP, OnChangeEdtSimtimestep)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSimConfigDlg message handlers

BOOL CSimConfigDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	switch (m_FileType)
	{
		case SAFT:
			CheckDlgButton(IDC_RAD_SAFT,1);
			break;
		case CASTOR:
			CheckDlgButton(IDC_RAD_CASTOR,1);
			break;
		default:
			CheckDlgButton(IDC_RAD_CASTOR,1);
	}

	return TRUE;
}

void CSimConfigDlg::OnBtnFileInPick() 
{
	// szFilters is a text string that includes two file name filters:
	// "*.my" for "MyType Files" and "*.*' for "All Files."
	//char CChildFrame::szFilters[] = ;

	CFileDialog FileDlg(
		TRUE,	// TRUE if File Open, FALSE if File Save As
		NULL,	// the default file extension
		NULL,	// the initial filename that appears
		OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY,//flags for customizing the appearance
		"All Files (*.*)|*.*||",	// file filters
		this); // pointer to FileCialog's parent object
	
   if(FileDlg.DoModal() == IDOK)
   {
      m_FileIn = FileDlg.GetPathName();
	  UpdateData(FALSE); // The FALSE switches the direction of the DDX
   }
}

void CSimConfigDlg::OnBtnFileOutPick() 
{
	// szFilters is a text string that includes two file name filters:
	// "*.my" for "MyType Files" and "*.*' for "All Files."
	//char CChildFrame::szFilters[] = ;

	CFileDialog FileDlg(
		FALSE,			// TRUE if File Open, FALSE if File Save As
		_T("*.txt"),	// the default file extension
		NULL,			// the initial filename that appears
		OFN_PATHMUSTEXIST | OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,//flags for customizing the appearance
		"text files (*.txt) |*.txt|All Files (*.*)|*.*||",	// file filters
		this); // pointer to FileCialog's parent object
	
   if(FileDlg.DoModal() == IDOK)
   {
      m_FileOut = FileDlg.GetPathName();
	  UpdateData(FALSE); // The FALSE switches the direction of the DDX
   }
}

void CSimConfigDlg::OnOK() 
{
	CDialog::OnOK();
}

void CSimConfigDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}

void CSimConfigDlg::OnRadCastor() 
{
	m_FileType = CASTOR;
}

void CSimConfigDlg::OnRadSaft() 
{
	m_FileType = SAFT;
}

void CSimConfigDlg::OnChangeEdtRoadlength() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	
}

void CSimConfigDlg::OnEditchangeCmbLanesdirPos() 
{
	// TODO: Add your control notification handler code here
	
}

void CSimConfigDlg::OnEditchangeCmbLanesdirNeg() 
{
	// TODO: Add your control notification handler code here
	
}

void CSimConfigDlg::OnChangeEdtSimtimestep() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	
}
