#if !defined(AFX_TRAFFICCONFIGDLG_H__6AA97537_057C_46E9_B1CC_B08FC4C93A1D__INCLUDED_)
#define AFX_TRAFFICCONFIGDLG_H__6AA97537_057C_46E9_B1CC_B08FC4C93A1D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// TrafficConfigDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CTrafficConfigDlg dialog

#include "GridCtrl_src/GridCtrl.h"
#include "IDMParameterSet.h"
#include "Parameter.h"
#include "Distribution.h"

class CTrafficConfigDlg : public CDialog
{
// Construction
public:
	CTrafficConfigDlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CTrafficConfigDlg)
	enum { IDD = IDD_TRAFFICCONFIG };
	CComboBox	m_cmbVehicleClassCopy;
	CComboBox	m_cmbVehicleClassDefine;
	int		m_nFixCols;
	int		m_nFixRows;
	int		m_nCols;
	int		m_nRows;
	CStringArray m_sDistributions;
	CIDMParameterSet m_IDMParams_Car;
	CIDMParameterSet m_IDMParams_SmallTruck;
	CIDMParameterSet m_IDMParams_LargeTruck;
	CIDMParameterSet m_IDMParams_Crane;
	CIDMParameterSet m_IDMParams_Lowloader;
	//}}AFX_DATA
	CGridCtrl m_Grid;

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTrafficConfigDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CTrafficConfigDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnBtnCopy();
	afx_msg void OnSelchangeCmbClassCopy();
	afx_msg void OnSelchangeCmbClassDefine();
	void OnGridEndEdit(NMHDR *pNotifyStruct, LRESULT* pResult);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	CParameter*			MapRowToParameter(int row);
	void				SetParamData(int row, int col, double val);
	void				SetParamData(int row, int col, CString str);
	CIDMParameterSet*	MapIDMParamSet(int iSelect);
	void				LoadRow(int row);
	WORD				MapDistributionString(CString dist);
	CString				MapDistributionID(WORD distID);
	void				LoadParamsIntoGrid();
	void				SetCells();
	void				SetGridHeadings();
	
	CIDMParameterSet*	m_pCurrentIDMParamSet;
	CIDMParameterSet*	m_pCopyIDMParamSet;	
	CStringArray		m_sCmbOptions;
	CStringArray		m_sRowHeaders;
	CStringArray		m_sColumnHeaders;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TRAFFICCONFIGDLG_H__6AA97537_057C_46E9_B1CC_B08FC4C93A1D__INCLUDED_)
