// Truck.h: interface for the Truck class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TRUCK_H__4FAD4F73_3B9C_4D49_A94D_548AED8B7A7B__INCLUDED_)
#define AFX_TRUCK_H__4FAD4F73_3B9C_4D49_A94D_548AED8B7A7B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <string>
#include <fstream>
#include <vector>

#include "Axle.h"
#include "Vehicle.h"


	/** A class to represent a Truck */

class Truck : public Vehicle {

public:	
	void doSAFTData(char* pTruck, const double curTime);
	void doCASTORData(char* pTruck, const double curTime);
	void createSAFTTruck(std::string data);
	void createCASTORTruck(std::string data);
	void setDriver();
	void setNoAxles(int axNo);
	void setGVW(double weight);

	/** Default constructor */
	Truck();



	/** Default destructor */
	virtual ~Truck();

	void setAW(int i, double w);

	void setAS(int i, double s);






	double getGVW();

	int getNoAxles();

	double getAS(int i);

	double getAW(int i);


	bool operator==(Truck& x);

	bool operator<(const Truck& x);

	double getTime() const;


	void returnTruckData(int truckData[]);


private:
	void setTime(const double t);

	std::vector<Axle*> axles;
	int noAxles;
	double overhangFront, overhangBack;
	double GVW;
	int hour, min, sec, hndt;
	int day, month, year;
	int trns;
	int head;
	int order;

	int dir;		// KEPT TEMPORARILY FOR LEGACY

};

#endif // !defined(AFX_TRUCK_H__4FAD4F73_3B9C_4D49_A94D_548AED8B7A7B__INCLUDED_)
