// TruckGroup.cpp: implementation of the TruckGroup class.
//
//////////////////////////////////////////////////////////////////////

#include "TruckGroup.h"

using namespace std;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

TruckGroup::TruckGroup()
{

}

TruckGroup::TruckGroup(std::string file)
{
	in.open( file.c_str(), ios::in );
	commonConstructor(file);
	m_ArrS = 0;
}

TruckGroup::TruckGroup(std::string file, const int* pArrS)
{
	commonConstructor(file);
	m_ArrS = *pArrS;
}

void TruckGroup::commonConstructor(std::string file)
{
	truckCount = 0;
//	m_preAmble = G.preAmble;
	getTruckCountFromFile(file); // in order to reserve for the vector
	m_vTrucks.reserve(truckCount);
	readTruckFile(file);
}

TruckGroup::~TruckGroup()
{

}

void TruckGroup::displayTruck(int truckNo)
{
	int truckData[33];
//	m_vTrucks[truckNo - 1]->returnTruckData(truckData);
	for(int i = 0; i < 33; i++)
	{
		std::cout << truckData[i] << endl;
	}
	std::cout << endl;
}

void TruckGroup::writeTruckFile(const std::string file)
{
	// ofstream constructor opens file
	const char* pFile;	pFile = file.c_str();
	ofstream outFile( pFile, ios::out );
    
	// check to see if file was created
	if( !outFile ){
		std::cerr << "File could not be opened" << endl;
		exit( 1 );
	}

//	detTruckCount();

	char singleTruck[78];
	char* pTruck = singleTruck;
	// for each truck
	for(int i = 0; i < truckCount; i++)
	{
		// assemble truck data into a string
//		if( m_pTrucks[i].DAY <= 3 && m_pTrucks[i].MONTH == 1 )
//		{
//			m_vTrucks[i]->doTruckData(pTruck);
			outFile.width(78);
			outFile << singleTruck << '\n';
//		}
	}
	outFile.close();
}

void TruckGroup::readTruckFile(std::string file)
{
	std::string str;

	ifstream inFile( file.c_str(), ios::in );

	// check to see if file was created
	if( !inFile ){
		std::cerr << "File could not be opened" << endl;
		exit( 1 );
	}

	for(int i = 0; i < truckCount; i++)
	{
		getline(inFile, str, '\n');
		if(str != "")
		{
			Truck* tempTruck = new Truck();
//			m_vTrucks[i] = tempTruck;
			m_vTrucks.push_back(tempTruck);
		}
	}
	inFile.close();

}

int TruckGroup::returnTruckCount(){
	return truckCount;
}

int TruckGroup::NoTrucksInLane(int lane)
{
	int count = 0;
	for(int i = 0; i < truckCount; i++)
	{
//		if(m_vTrucks[i].LANE == lane) count++;
	}
	return count;
}

int TruckGroup::NoTrucksInDir(int dir)
{
	int count = 0;
	for(int i = 0; i < truckCount; i++)
	{
//		if(m_vTrucks[i].DIRN == dir) count++;
	}
	return count;
}

int TruckGroup::getTruckCountFromFile(std::string file)
{
	ifstream inFile( file.c_str(), ios::in );

	std::string str;
    
	// check to see if file was created
	if( !inFile ){
		std::cerr << "File could not be opened" << endl;
		exit( 1 );
	}

	while(!inFile.eof()){
		getline(inFile, str, '\n');
		if(str != "") 
			truckCount++;
	}
	//inFile.close();
	// this used to have a -1 after it:
	return truckCount;
}

std::vector<Truck*> TruckGroup::getTrucks(){
	return m_vTrucks;
}
