// TruckGroup.h: interface for the CTruckGroup class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TRUCKGROUP1_H__FF168275_C129_4A79_B411_62B300CBA1A1__INCLUDED_)
#define AFX_TRUCKGROUP1_H__FF168275_C129_4A79_B411_62B300CBA1A1__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <iostream>
#include <fstream>
#include <stdlib.h>
#include <string>
#include <vector>

#include "Truck.h"

class TruckGroup  
{
public:
	std::vector<Truck*> getTrucks();
	TruckGroup();
	int getTruckCountFromFile(std::string file);
	int NoTrucksInDir(int dir);
	int NoTrucksInLane(int lane);
	int returnTruckCount();
	TruckGroup(std::string file, const int* pArrS);
	TruckGroup(std::string file);
	virtual ~TruckGroup();
	void readTruckFile(std::string file);
	void displayTruck(int truckNo);
	void writeTruckFile(const std::string file);

private:
	void commonConstructor(std::string file);
	double m_MaxSpan;
	int m_ArrS;
	int m_preAmble;
	std::vector<Truck*> m_vTrucks;
	int truckCount;
	std::ifstream in;
};

#endif // !defined(AFX_TRUCKGROUP1_H__FF168275_C129_4A79_B411_62B300CBA1A1__INCLUDED_)
