#ifndef _VEHICLE_H
#define _VEHICLE_H

#include "IDM.h"
#include <vector>
#include <fstream>

	/** A Base class from which specific Vehicle types are derived*/

class Vehicle {

public:
	Vehicle();
	virtual ~Vehicle();
	
	// the sets
	void	setChangeStatus(bool stat);
	void	setRoadPos(double r);
	void	setPos(double p);
	// desired velocity set?
	void	setAccel(double acceler);
	void	setLength(double length);
	void	setVelocity(double velocity);
	void	setLane(int l);	
	void	setDirection(bool DirPointsRight); //int d);

	// the gets
	bool	getChangeStatus();	
	double	getRoadPos();
	double	getPos();
	double	getDesiredVel();	// why is there no set for this??
	double	getAccel();
	double	getLength();
	double	getVelocity();
	double	getLane();
	bool	getDirection(); //int
	
	DriverModel* getDriver();
	void	setDriver(IDM driver);

	void	updateProperties(double step, double accel);
	void	update(double step, Vehicle *pV);
	void	update(double step);
	virtual void doSAFTData(char* pTruck,const double curTime);
	virtual void doCASTORData(char* pTruck,const double curTime);

	int		getID();
	double	calcAccel();
	bool	changeTime(double step);
	double	calcAccel(Vehicle* pV);
	int		DecideLaneChange(Vehicle* LeftFrontVehicle, Vehicle* LeftBackVehicle,
							 Vehicle* RightFrontVehicle, Vehicle* RightBackVehicle,
							 bool LeftLaneExists,		bool RightLaneExists);
	int DecideNextLane(double LeftAdv, double RightAdv);
	double DecideLaneChange(Vehicle* frontVeh, Vehicle* backVeh, bool overtake);

protected:
	DriverModel* m_pDriver;
	IDM		m_IDMDriver;

	double	LaneChangeAdvantage(Vehicle* FrontVehicle, Vehicle* BackVehicle, bool overtake);

	double	len;
	double	vel;
	double	acc;
	double	lane;
	double	m_x;
	bool	m_DirPos;
	double	roadPos;
	int		ID;
	bool	laneChange;

	double	tdelay;		// what's this???
};
#endif
